# Une urne contient cinq boules numrote de 1  5 .
# On tire au hasard avec remise 10 boules de l'urne.
# On appelle succs, lors d'un tirage, l'apparirion de la boule 1.
# On appelle X la variable aleatoire prenant pour valeur le nombre
# de boules numrotes 1
#***************************** 1. Premire exprience*******************
#- AlgoHyp312_30()-simulation d'une valeur-algorithme de l'nonc - runif
# Modle d'urne boules numrotes, tirage avec remise
AlgoHyp312_30 <- function(){
  S <- 0
  for(i in 1:10){
    x <- floor(1 + 5 * runif(1, 0, 1))
    if(x == 1) S <- S + 1
  }
# Affichage du rsultat
  cat("\nNombre de boules n 1=", S, "\n")
}

#----------------------------------------------------------------------
#-- AlgoHyp312_30_1()--simulation d'une valeur avec sample dans urne
# Modle d'urne boules numrotes, tirage avec remise
AlgoHyp312_30_1 <- function(){
  S <- 0
  for(i in 1:10){
    x <- sample(1:5, 1)
    if(x == 1) S <- S + 1
  }
# Affichage du rsultat
  cat("Nombre de boules n 1 =", S, "\n")
}

#----------------------------------------------------------------------
#-- AlgoHyp312_30_2()--simulation d'une valeur avec sample dans urne
# Modle d'urne boules numrotes, tirage avec remise
AlgoHyp312_30_2 <- function(){
  S <- 0
  urne <- 1:5
  for(i in 1:10){
    x <- sample(urne, 1)
    if(x == 1) S <- S + 1
  }
# Affichage du rsultat
  cat("\nNombre de boules n 1=", S, "\n")
}

#----------------------------------------------------------------------
#-- AlgoHyp312_30_3()--simulation d'une valeur avec sample dans urne
# Modle d'urne boules numrotes, tirage avec remise
AlgoHyp312_30_3 <- function(){
  urne <- 1:5
  x <- sample(urne, 10, replace = TRUE)
  S <- sum(x == 1)
# Affichage du rsultat
  cat("\nNombre de boules n 1=", S, "\n")
}

#----------------------------------------------------------------------
#-- AlgoHyp312_30_4()-- simulation d'une valeur ... avec paramtres
# Modle d'urne boules numrotes, tirage avec remise
AlgoHyp312_30_4 <- function(nbboules = 5, nbtirages = 10, numero = 1){
  urne <- 1:nbboules
  x <- sample(urne, nbtirages, replace = TRUE)
  S <- sum(x == numero)
# Affichage du rsultat
  cat("Nombre de boules n", numero, "=", S, "\n")
}

#----------------------------------------------------------------------
#-- AlgoHyp312_30_5()-- Distribution simule de la variable
# Modle d'urne boules numrotes, tirage avec remise
AlgoHyp312_30_5 <- function(nbboules = 5, nbtirages = 10, numero = 1,
                            nbsim = 2000){
  urne <- 1:nbboules
  seriesimul <- NULL
  for(i in 1:nbsim){
    x <- sample(urne, nbtirages, replace = TRUE)
    seriesimul[i] <- sum(x == numero)
  }
  tabloFreq <- table(seriesimul) / nbsim
# Affichage des rsultats et des graphiques
  cat("Distribution simule du nombre de boules n", numero, ":\n")
  print(tabloFreq)
  barplot(tabloFreq)
}

#----------------------------------------------------------------------
#-- AlgoHyp312_30_6()-- Distribution simule de la variable
# Modle d'urne classique, boules non numrots, tirage avec remise
AlgoHyp312_30_6 <- function(nbrouges = 1, nbtot = 5, nbtirages = 10,
                            nbsim = 2000){
  urne <- rep(c("Rouge", "Autre"), c(nbrouges, nbtot - nbrouges))
  seriesimul <- NULL
  for(i in 1:nbsim){
    x <- sample(urne, nbtirages, replace = TRUE)
    seriesimul[i] <- sum(x == "Rouge")
  }
  tabloFreq <- table(seriesimul) / nbsim
# Affichage des rsultats et des graphiques
  cat("\nDistribution simule du nombre de boules rouges:\n")
  print(tabloFreq)
  barplot(tabloFreq)
}

#----------------------------------------------------------------------
#-- AlgoHyp312_30_7()-- Distribution simule de la variable
# Modle roulette  secteurs numrots , nblancers, touchers
AlgoHyp312_30_7 <- function(nbsecteurs = 5, nblancers = 10, numero = 1,
                            nbsim = 2000){
  roulette <- 1:nbsecteurs
  seriesimul <- NULL
  for(i in 1:nbsim){
    x <- sample(roulette, nblancers, replace = TRUE)
    seriesimul[i] <- sum(x == numero)
  }
  tabloFreq <- table(seriesimul) / nbsim
# Affichage des rsultats et des graphiques
  cat("\nDistribution simule du nombre de touchers du", numero, ":\n")
  print(tabloFreq)
  barplot(tabloFreq)
}

#*************************************************************
#****************On fait rfrence  des modles********
#-- AlgoHyp312_30_8()-- Distribution simule de la variable
# n preuves de Bernoulli rptes (indpendantes)
AlgoHyp312_30_8 <- function(n = 10, p = 1 / 5, nbsim = 2000){
  deuxalternatives = c("succes", "echec")
  seriesimul <- NULL
  for(i in 1:nbsim){
    x <- sample(deuxalternatives, n, prob = c(p, 1 - p), replace = TRUE)
    seriesimul[i] <- sum(x == "succes")
  }
  tabloFreq <- table(seriesimul) / nbsim
# Affichage des rsultats et des graphiques
  cat("Distribution simule du nombre de succs :\n")
  print(tabloFreq)
  barplot(tabloFreq, ylab = "Frquences similes",
     xlab = "Nombre de succs",
  	  main = "Distribution simule du nombre de succs")
}

#----------------------------------------------------------------------
#-- AlgoHyp312_30_9()-- Distribution simule de la variable
# FONCTION rbinom() : plus besoin de boucle nbsim
# Superposition dans le graphique en barres des probabilits binomiales
# 2 fentres graphiques plot-points et barplot-points
# Il faut un tableau des frquences simules avec toutes les valeurs de X
AlgoHyp312_30_9 <- function(n = 10, p = 1 / 5, nbsim = 2000, echelY = .4){
  seriesimul <- rbinom(nbsim, n, p)
  tabloFreq <- table(seriesimul) / nbsim
  ValeursX <- 0:n
  tableauFreq <- rep(0, n + 1)
  names(tableauFreq) <- ValeursX
  tableauFreq[as.numeric(names(tabloFreq)) + 1] <- tabloFreq
  probabino <- dbinom(ValeursX, n, p)
  names(probabino) <- ValeursX
# Affichage des tableaux de distribution
  cat("Distribution simule du nombre de succs :\n")
  print(tableauFreq)
  cat("\nDistribution thorique du nombre de succs (loi binomiale) :\n")
  print(probabino)
# Graphiques superposant plot et points
  graphics.off()
  plot(ValeursX, tableauFreq, type = "h", xaxp = c(0, n, n),
    ylim = c(0, echelY), ylab = "Frquences", xlab = "Nombre de succs",
    main = "Diagramme en barres et en points binomial")
    points(ValeursX, probabino, pch = 21, col = "red", bg = "red")
    legend(x = "topleft",
      legend = c("Frquences simules", "Probabilits"),
      bg = "grey90", pch = c(124, 21), pt.cex = c(1, 1),
      col = c("black", "red"), pt.bg = c(NA, "red"))
# Graphiques superposant barplot et points
  dev.new()
    barplot(tableauFreq, ylim = c(0, echelY),
      ylab = "Frquences", xlab = "Nombre de succs",
      main = "Diagramme en barres et en points binomial")
      points(barplot(1:(n + 1), plot = FALSE), probabino,
        pch = 21, col = "red", bg = "red")
      legend(x = "topleft",
        legend = c("Frquences simules", "Probabilits"),
        bg = "grey90", pch = c(22, 21), pt.cex = c(1, 1),
        col = c("black", "red"), pt.bg = c("grey", "red"))
}

#----------------------------------------------------------------------
#-- AlgoHyp312_30_9bis()-- Distribution simule de la variable
# FONCTION rbinom() : plus besoin de boucle nbsim
# Superposition de l'histogramme et de la densit gaussienne
AlgoHyp312_30_9bis <- function(n = 10, p = 1 / 5, nbsim = 2000){
  EX <- n * p ; EtX <- sqrt(n * p * (1 - p))
  bornes <- seq(-.5, (n + .5), 1)
  seriesimul <- rbinom(nbsim, n, p)
  ValeursXGauss <- seq(-.5, (n + .5), length = 1000)
  DensiteGauss <- dnorm(ValeursXGauss, EX, EtX)
# Graphiques superposant histogramme et densit gaussienne
  hist(seriesimul, breaks = bornes, freq = FALSE,
    main = "Histogramme de la srie simule et densit gaussienne",
    xlab = "Nombre de succs")
    points(ValeursXGauss, DensiteGauss, type = "l", col = "red")
    legend(x = "topright",
      legend = c("Densit simule", "Densit gaussienne"),
        bg = "grey90", pch = c(95, 95), pt.cex = c(1, 1.3),
        col = c("black", "red"))
}

#***************************** 2. Gnralisation*******************
#-- AlgoHyp312_30_10()    simulation d'une valeur ... avec paramtres
# Modle d'urne boules numrotes, tirages avec remise
AlgoHyp312_30_10 <- function(n = 10, B = 5, m = 2){
  urne <- 1:B
  x <- sample(urne, n, replace = TRUE)
  S <- sum(x <= m)
# Affichage du rsultat
  cat("Nombre de boules de n compris entre 1 et", m, "=", S, "\n\n")
}

#------------------------------------------------------------
# probazero() utilise une version modifie de
# AlgoHyp312_30_10() dans une boucle
# X est la V.A. nombre de boules dont le numro est compris entre
# 1 et m(2) parmi n (10)  boules tires au hasard avec remise dans une
# urne de B(5) boules numrotes de 1  B
# pour estimer (avec 2000 simulations) P(X = 0)
AlgoHyp312_30_10 <- function(n = 10, B = 5, m = 2){
  urne <- 1:B
  x <- sample(urne, n, replace = TRUE)
  S <- sum(x <= m)
  return(S)
}

probazero <- function(){
  z <- 0
  for(i in 1:2000) {z <- z + sum(AlgoHyp312_30_10() == 0)}
  cat("Une estimation de P(X = 0) :", z / 2000, "\n\n")
}

######Quelques variations autour de la superposition de graphiques#####
# pour comparer frquences simules et probabilits.
#**Lignes de commandes******AlgoHyp312_30_11
#-----Deux fentres graphiques pour plot-points et barplot-points
nbsim <- 200 ; n <- 10 ; p <- .2 ; echelY <- .4
valeurX <- 0:n
bin1 <- rbinom(nbsim, n, p)
(tablebin1 <- table(bin1, dnn = "tablebin1") / nbsim)
# attributes(tablebin1)
(tableFreqX <- rep(0, n + 1))
(names(tableFreqX) <- valeurX)
tableFreqX[as.numeric(names(tablebin1)) + 1] <- tablebin1
tableFreqX
# attributes(tableFreqX)
(binotheo1 <- dbinom(valeurX, n, p))
# On ferme tous les graphiques prcdents
graphics.off()
# Graphiques superposant plot et points dans une nouvelle fentre
plot(valeurX, tableFreqX, type = "h",
  xaxp = c(0, n, n), ylim = c(0, echelY),
  ylab = "Frquences", xlab = "Nombre de succs", cex.axis = .7,
  main = "Diagramme en barres et en points binomial")
  points(valeurX, binotheo1,
    pch = 21, col = "red", bg = "red")
  legend(x = "topright",
    legend = c("Frquences simules", "Probabilits"),
    bg = "grey90", pch = c(124, 21), pt.cex = c(1, 1),
    col = c("black", "red"), pt.bg = c(NA, "red"))
# On ouvre une nouvelle fentre graphique
dev.new()
# Graphiques superposant barplot et points dans cette nouvelle fentre
barplot(tableFreqX, ylim = c(0, echelY), cex.axis = .7, cex.names = .7,
    ylab = "Frquences", xlab = "Nombre de succs",
    main = "Diagramme en barres et en points binomial")
  points(barplot(1:(n + 1), plot = FALSE), binotheo1,
    pch = 21, col = "red", bg = "red")
  legend(x = "topright",
    legend = c("Frquences simules", "Probabilits"),
    bg = "grey90", pch = c(22, 21), pt.cex = c(1, 1),
    col = c("black", "red"), pt.bg = c("grey", "red"))

#----------------------------------------------------------------------
#**Lignes de commandes******AlgoHyp312_30_12
#-Une fentre graphique partage en 2 pour plot-points et barplot-points
nbsim <- 200 ; n <- 10 ; p <- .2 ; echelY <- .4
valeurX <- 0:n
bin1 <- rbinom(nbsim, n, p)
(tablebin1 <- table(bin1, dnn = "tablebin1") / nbsim)
# attributes(tablebin1)
(tableFreqX <- rep(0, n + 1))
(names(tableFreqX) <- valeurX)
tableFreqX[as.numeric(names(tablebin1)) + 1] <- tablebin1
tableFreqX
# attributes(tableFreqX)
(binotheo1 <- dbinom(valeurX, n, p))
# Partage de la fentre graphique en deux
par(mfrow = c(2, 1))
# Graphiques superposant plot et points
plot(valeurX, tableFreqX, type = "h",
  xaxp = c(0, n, n), ylim = c(0, echelY),
  ylab = "Frquences", xlab = "Nombre de succs",
  main = "Diagramme en barres et en points binomial")
  points(valeurX, binotheo1,
    pch = 21, col = "red", bg = "red")
  legend(x = "topright",
    legend = c("Frquences simules", "Probabilits"),
    bg = "grey90", pch = c(124, 21), pt.cex = c(1, 1),
    col = c("black", "red"), pt.bg = c(NA, "red"))
# Graphiques superposant barplot et points
barplot(tableFreqX, ylim = c(0, echelY), ylab = "Frquences",
    xlab = "Nombre de succs",
    main = "Diagramme en barres et en points binomial")
  points(barplot(1:(n + 1), plot = FALSE), binotheo1,
    pch = 21, col = "red", bg = "red")
  legend(x = "topright",
    legend = c("Frquences simules", "Probabilits"),
    bg = "grey90", pch = c(22, 21), pt.cex = c(1, 1),
    col = c("black", "red"), pt.bg = c("grey", "red"))

